module BigFont where

import Data.Map qualified as Map
import Data.Map (Map)
import Data.Maybe
import Data.List (intersperse, transpose)

bigText :: String -> [String]
bigText = map concat . transpose . intersperse sep . mapMaybe \x -> Map.lookup x letters

sep :: [String]
sep = [" " ," " ," " ," " ," "]

letters :: Map Char [String]
letters = Map.fromList
 [(' ',
   ["   "
   ,"   "
   ,"   "
   ,"   "
   ,"   "]),
  ('?',
   ["██████ "
   ,"     ██"
   ,"  ▄███ "
   ,"  ▀▀   "
   ,"  ██   "]),
  ('A',
   [" █████ "
   ,"██   ██"
   ,"███████"
   ,"██   ██"
   ,"██   ██"]),
  ('B',
   ["██████ "
   ,"██   ██"
   ,"██████ "
   ,"██   ██"
   ,"██████ "]),
  ('C',
   [" ██████"
   ,"██     "
   ,"██     "
   ,"██     "
   ," ██████"]),
  ('D',
   ["██████ "
   ,"██   ██"
   ,"██   ██"
   ,"██   ██"
   ,"██████ "]),
  ('E',
   ["███████"
   ,"██     "
   ,"█████  "
   ,"██     "
   ,"███████"]),
  ('F',
   ["███████"
   ,"██     "
   ,"█████  "
   ,"██     "
   ,"██     "]),
  ('G',
   [" ██████ "
   ,"██      "
   ,"██   ███"
   ,"██    ██"
   ," ██████ "]),
  ('H',
   ["██   ██"
   ,"██   ██"
   ,"███████"
   ,"██   ██"
   ,"██   ██"]),
  ('I',
   ["██"
   ,"██"
   ,"██"
   ,"██"
   ,"██"]),
  ('J',
   ["     ██"
   ,"     ██"
   ,"     ██"
   ,"██   ██"
   ," █████ "]),
  ('K',
   ["██   ██"
   ,"██  ██ "
   ,"█████  "
   ,"██  ██ "
   ,"██   ██"]),
  ('L',
   ["██     "
   ,"██     "
   ,"██     "
   ,"██     "
   ,"███████"]),
  ('M',
   ["███    ███"
   ,"████  ████"
   ,"██ ████ ██"
   ,"██  ██  ██"
   ,"██      ██"]),
  ('N',
   ["███    ██"
   ,"████   ██"
   ,"██ ██  ██"
   ,"██  ██ ██"
   ,"██   ████"]),
  ('O',
   [" ██████ "
   ,"██    ██"
   ,"██    ██"
   ,"██    ██"
   ," ██████ "]),
  ('P',
   ["██████ "
   ,"██   ██"
   ,"██████ "
   ,"██     "
   ,"██     "]),
  ('Q',
   [" ██████ "
   ,"██    ██"
   ,"██    ██"
   ,"██ ▄▄ ██"
   ," ██████ "]),
  ('R',
   ["██████ "
   ,"██   ██"
   ,"██████ "
   ,"██   ██"
   ,"██   ██"]),
  ('S',
   ["███████"
   ,"██     "
   ,"███████"
   ,"     ██"
   ,"███████"]),
  ('T',
   ["████████"
   ,"   ██   "
   ,"   ██   "
   ,"   ██   "
   ,"   ██   "]),
  ('U',
   ["██    ██"
   ,"██    ██"
   ,"██    ██"
   ,"██    ██"
   ," ██████ "]),
  ('V',
   ["██    ██"
   ,"██    ██"
   ,"██    ██"
   ," ██  ██ "
   ,"  ████  "]),
  ('W',
   ["██     ██"
   ,"██     ██"
   ,"██  █  ██"
   ,"██ ███ ██"
   ," ███ ███ "]),
  ('X',
   ["██   ██"
   ," ██ ██ "
   ,"  ███  "
   ," ██ ██ "
   ,"██   ██"]),
  ('Y',
   ["██    ██"
   ," ██  ██ "
   ,"  ████  "
   ,"   ██   "
   ,"   ██   "]),
  ('Z',
   ["███████"
   ,"   ███ "
   ,"  ███  "
   ," ███   "
   ,"███████"]),
  ('0',
   [" ██████ "
   ,"██  ████"
   ,"██ ██ ██"
   ,"████  ██"
   ," ██████ "]),
  ('1',
   [" ██"
   ,"███"
   ," ██"
   ," ██"
   ," ██"]),
  ('2',
   ["██████ "
   ,"     ██"
   ," █████ "
   ,"██     "
   ,"███████"]),
  ('3',
   ["██████ "
   ,"     ██"
   ," █████ "
   ,"     ██"
   ,"██████ "]),
  ('4',
   ["██   ██"
   ,"██   ██"
   ,"███████"
   ,"     ██"
   ,"     ██"]),
  ('5',
   ["███████"
   ,"██     "
   ,"███████"
   ,"     ██"
   ,"███████"]),
  ('6',
   [" ██████ "
   ,"██      "
   ,"███████ "
   ,"██    ██"
   ," ██████ "]),
  ('7',
   ["███████"
   ,"     ██"
   ,"    ██ "
   ,"   ██  "
   ,"   ██  "]),
  ('8',
   [" █████ "
   ,"██   ██"
   ," █████ "
   ,"██   ██"
   ," █████ "]),
  ('9',
   [" █████  "
   ,"██   ██ "
   ," ██████ "
   ,"     ██ "
   ," █████  "])]
